import java.util.*;

public class Schild {
    Form f = new Form();
    private LinkedList<Verbindung> quadrate;
    private LinkedList<Verbindung> quader;
    private LinkedList<Verbindung> dreiecke;
    private LinkedList<Verbindung> achtecke;
    private LinkedList<Verbindung> grossePolygone;
    private LinkedList<Verbindung> alleSchilder = new LinkedList<Verbindung>();

   
    private int[] gelb = {255,204,0};
    private int[] gelbgold = {183, 149, 14};
    private int[] blassrot = {223, 139, 139};
    private int[] rot = {255,0,0};
    private int[] blau = {0, 51, 153};
    private int[] weiss = {255, 255, 255};
    private int[] hellgrau = {144, 144, 144};
    private int[] gelbgrau = {43, 42, 41};
    private int[] blaugrau = {0, 40, 150};
    private int[] blassgrau = {219, 223, 237};
    private int[] dunklesgrau = {88, 86, 87};
    private int[] sehrdunklesgrau = {111, 111, 111};
    private int[] schwarz = {0,0,0};
    private final float minFU = 80;//Maximaler Farbunterschied zwischen zwei Farben, die ähnlich sind
    private final int aFP = 40;//Anzahl der zu untersuchenden Farbpunkte auf einer Linie
    //Im folgenden werden die erkannten Schilder gespeichert
    //Dabei steht der Index im Array für unterschiedliche Schilder
    //[VFS, HVG]
    private boolean[] schilder = new boolean[5];
    private PImage image;

public Schild(ArrayList<Line> alleLinien, PImage image) {
        this.image = image;
        for (int i = 0; i<alleLinien.size();i++)f.addLine(alleLinien.get(i));
        quadrate = f.getQuadrate();
        quader = f.getQuader();
        dreiecke = f.getDreiecke();
        achtecke = f.getAchtecke();
        grossePolygone = f.getGrossePolygone();
        for (int i = 0; i<quadrate.size();i++){
            if (istVFS(quadrate.get(i))){
                alleSchilder.add(quadrate.get(i).copy());
                schilder[0] = true;
            }
        }
        for (int i = 0; i<achtecke.size();i++){
            if (istHVG(achtecke.get(i))){
                alleSchilder.add(achtecke.get(i).copy());
                schilder[1] = true;
            }
        }
        for (int i = 0; i<quader.size();i++){
            if(istSpS(quader.get(i))){
                alleSchilder.add(quader.get(i).copy());
                schilder[2] = true;
            }
        }
        for (int i = 0; i<dreiecke.size();i++){
            if (istVG(dreiecke.get(i))){
                alleSchilder.add(dreiecke.get(i).copy());
                schilder[3] = true;
            }
            if (istWZ(dreiecke.get(i))){
                alleSchilder.add(dreiecke.get(i).copy());
                schilder[4] = true;
            }
        }
    }
    public LinkedList<Line> getSchilder(){//gibt die Linien aller Schilder zurück
        LinkedList<Line> schilderLinien = new LinkedList<Line>();
        for (int a = 0; a<alleSchilder.size();a++){
            Verbindung v = alleSchilder.get(a);
            LinkedList<Line> vLinien = v.getForm();
            for (int b = 0; b<vLinien.size();b++)schilderLinien.add(vLinien.get(b));
        }
        return schilderLinien;
    }
    public String erkannteSchilder(){
        String s = "";
        if(schilder[0])s = s+ "Vorfahrtstrasse, ";
        if(schilder[1])s = s+ "Stopschild, ";
        if (schilder[2])s = s+ "Spielstraße, ";
        if (schilder[3])s = s+ "Vorfahrt gewähren, ";
        if (schilder[4])s = s+ "Warnzeichen, ";
        if (s.isEmpty())return s+"Keine Schilder erkannt.";
        else s = s.substring(0, s.length()-2) + ".";
        return "Folgende Schilder wurden erkannt: "+s;
    }
    private boolean istVFS(Verbindung v){//prüft auf Vorfahrtsstraße
        LinkedList<Punkt> vier = v.getPunkte();
        float vx = vier.get(2).x-vier.get(0).x;
        float vy = vier.get(2).y-vier.get(0).y;
        float vx2 = vier.get(3).x-vier.get(1).x;
        float vy2 = vier.get(3).y-vier.get(1).y;
        int[][] FarbeMuss = {weiss, gelb};
        int[][] FarbeDarf = {weiss, gelb, blassgrau,gelbgold, hellgrau, schwarz, gelbgrau,dunklesgrau,sehrdunklesgrau};
        boolean diagonale1 = enthaeltFarbe((int)vier.get(0).x,(int) vier.get(0).y, (int)vx, (int)vy , FarbeDarf, FarbeMuss);
        boolean diagonale2 = enthaeltFarbe((int)vier.get(1).x,(int) vier.get(1).y, (int)vx2, (int)vy2 , FarbeDarf, FarbeMuss);
        return (diagonale1 && diagonale2);
    }
    private boolean istHVG(Verbindung v){//prüft auf Halt, Vorfahrt gewären (Stopschild)
        LinkedList<Punkt> acht = v.getPunkte();
        float vx = acht.get(4).x-acht.get(0).x;
        float vy = acht.get(4).y-acht.get(0).y;
        float vx2 = acht.get(6).x-acht.get(2).x;
        float vy2 = acht.get(6).y-acht.get(2).y;
        int[][] FarbeMuss = {weiss, rot};
        int[][] FarbeDarf = {weiss, rot, blassrot};
        boolean diagonale1 = enthaeltFarbe((int)acht.get(0).x,(int) acht.get(0).y, (int)vx, (int)vy , FarbeDarf, FarbeMuss);
        boolean diagonale2 = enthaeltFarbe((int)acht.get(2).x,(int) acht.get(2).y, (int)vx2, (int)vy2 , FarbeDarf, FarbeMuss);
        return (diagonale1 && diagonale2);
    }
    private boolean istSpS(Verbindung v){//prüft auf Spielstraße
        LinkedList<Punkt> vier = v.getPunkte();
        float vx = vier.get(2).x-vier.get(0).x;
        float vy = vier.get(2).y-vier.get(0).y;
        float vx2 = vier.get(3).x-vier.get(1).x;
        float vy2 = vier.get(3).y-vier.get(1).y;
        int[][] FarbeMuss = {weiss, blau};
        int[][] FarbeDarf = {weiss, blau, blassgrau, hellgrau, blaugrau};
        boolean diagonale1 = enthaeltFarbe((int)vier.get(0).x,(int) vier.get(0).y, (int)vx, (int)vy , FarbeDarf, FarbeMuss);
        boolean diagonale2 = enthaeltFarbe((int)vier.get(1).x,(int) vier.get(1).y, (int)vx2, (int)vy2 , FarbeDarf, FarbeMuss);
        return (diagonale1 && diagonale2);
    }
    private boolean istVG(Verbindung v){//prüft auf Vorfahrt gewähren
        LinkedList<Punkt> drei = v.getPunkte();
        float vx = ((drei.get(2).x-drei.get(1).x)/2)+drei.get(1).x-drei.get(0).x;
        float vy = ((drei.get(2).y-drei.get(1).y)/2)+drei.get(1).y-drei.get(0).y;
        float vx2 = ((drei.get(2).x-drei.get(0).x)/2)+drei.get(0).x-drei.get(1).x;
        float vy2 = ((drei.get(2).y-drei.get(0).y)/2)+drei.get(0).y-drei.get(1).y;
        int[][] FarbeMuss = {rot, weiss};
        int[][] FarbeDarf = {rot, weiss, blassrot};
        boolean diagonale1 = enthaeltFarbe((int)drei.get(0).x,(int) drei.get(0).y, (int)vx, (int)vy , FarbeDarf, FarbeMuss);
        boolean diagonale2 = enthaeltFarbe((int)drei.get(1).x,(int) drei.get(1).y, (int)vx2, (int)vy2 , FarbeDarf, FarbeMuss);
        return (diagonale1 && diagonale2);
    }
    private boolean istWZ(Verbindung v){//prüft auf beliebiges Warnzeichen
        LinkedList<Punkt> drei = v.getPunkte();
        float vx = ((drei.get(2).x-drei.get(1).x)/2)+drei.get(1).x-drei.get(0).x;
        float vy = ((drei.get(2).y-drei.get(1).y)/2)+drei.get(1).y-drei.get(0).y;
        float vx2 = ((drei.get(2).x-drei.get(0).x)/2)+drei.get(0).x-drei.get(1).x;
        float vy2 = ((drei.get(2).y-drei.get(0).y)/2)+drei.get(0).y-drei.get(1).y;
        int[][] FarbeMuss = {rot, weiss, schwarz};
        int[][] FarbeDarf = {rot, weiss, schwarz, blassrot,dunklesgrau,sehrdunklesgrau,blassgrau,hellgrau};
        boolean diagonale1 = enthaeltFarbe((int)drei.get(0).x,(int) drei.get(0).y, (int)vx, (int)vy , FarbeDarf, FarbeMuss);
        boolean diagonale2 = enthaeltFarbe((int)drei.get(1).x,(int) drei.get(1).y, (int)vx2, (int)vy2 , FarbeDarf, FarbeMuss);
        return (diagonale1 && diagonale2);
    }
    private boolean enthaeltFarbe(int Startx, int Starty, int vx, int vy,int[][] Fd, int[][] Fm){//prüft ob die gegebenen Farben auf der Linie sind
        //Fm (Farbe muss) und Fd (Farbe darf) müssen die gleiche Farbreihenfolge haben !!!
        //z.B. Fm : blau, weiss  &  Fd : blau, weiss, dunkelgrau, schwarz
        int[] FarbeMuss = new int[Fm.length];
        for (int a = 1; a<aFP;a++){
            float[] moeglicheFarben = new float[Fd.length];
            for (int b = 0; b<moeglicheFarben.length;b++){
                moeglicheFarben[b] = farbDiff(Fd[b], ort((int)(Startx + vx*a/aFP),(int)(Starty + vy *a/aFP)));
            }
            for (int b = 0; b<Fm.length;b++)if(moeglicheFarben[b] < minFU)FarbeMuss[b]++;
            boolean farbeStimmt = false;
            for (int b = 0; b<Fd.length;b++)if(moeglicheFarben[b] < minFU)farbeStimmt = true;
            if (farbeStimmt == false){
                color c = ort((int)(Startx + vx*a/aFP),(int)(Starty + vy *a/aFP));
                //println("Fail: "+red(c)+" "+ green(c)+ " "+blue(c));
                //fill(c);
                //circle((int)(Startx + vx*a/aFP),(int)(Starty + vy *a/aFP),20);
                return false;
            }
        }
        for (int b = 0; b<FarbeMuss.length;b++)if(FarbeMuss[b]<3)return false;
        return true;
    }
    public float farbDiff(int[] Farbe1, color Farbe2){
        return (float) Math.sqrt(Math.pow(Farbe1[0]-red(Farbe2),2)+Math.pow(Farbe1[1]-green(Farbe2),2)+Math.pow(Farbe1[2]-blue(Farbe2),2));
    }
    public color ort(int x, int y){//gibt die Farbe zu einer x/y Position zurück
        //println("("+x+"/"+y+")");
        int o = x+y*image.width;
        color c = image.pixels[o];
        //fill(c);
        //circle(x,y,10);
        //println("Farbe : "+red(c)+" "+green(c)+" "+blue(c));
        return c;
    }
}
