public class Verbindung {
    private LinkedList<Line> linien;//alle Linien im original Zustand wie sie hinzugefügt worden sind
    private LinkedList<Float> laengeLinien;//Länge der Linie im veränderten Zustand (Position mit form übereinstimmend)
    private LinkedList<Punkt> punkte;//Punkte der sich bildenden Form
    private LinkedList<Line> form;//Die From die anhand der Punkte gebildet wird

    public float abweichung = (float) 0.3; //Spielraum
    public float minWinkelUnterschied = (float) (Math.PI/16);
    public boolean fullyConnected = false;

    public Verbindung() {
        linien = new LinkedList<Line>();
        punkte = new LinkedList<Punkt>();
        laengeLinien = new LinkedList<Float>();
        form = new LinkedList<Line>();
    }
    public Verbindung copy(){
        Verbindung v = new Verbindung();
        for(int i = 0; i<linien.size();i++){
            Line nl = new Line(linien.get(i).start.x,linien.get(i).start.y,linien.get(i).end.x,linien.get(i).end.y);
            v.linien.add(nl);
        }
        for(int i = 0; i<form.size();i++){
            Line nl = new Line(form.get(i).start.x,form.get(i).start.y,form.get(i).end.x,form.get(i).end.y);
            v.form.add(nl);
        }
        for(int i = 0; i<punkte.size();i++){
            Punkt np = new Punkt(punkte.get(i).x,punkte.get(i).y);
            v.punkte.add(np);
        }
        for(int i = 0; i<laengeLinien.size();i++)v.laengeLinien.add(laengeLinien.get(i));
        return v;
    }
    public LinkedList<Punkt> getPunkte(){
        return punkte;
    }
    public LinkedList<Line> getForm() {
        return form;
    }
    public LinkedList<Float> getLaengen() {
        return laengeLinien;
    }
    public LinkedList<Line> getLinien(){
        return linien;
    }
    public int anzahlPunkte() {
        return punkte.size();
    }

    public boolean addLine(Line l) {//Fügt die Linie der Verbindung hinzu, wenn die Linie passt wird true zurück gegeben
        if (fullyConnected)return false;
        if (linien.isEmpty()) {//Wenn die Verbindung bisher leer ist wird die Linie einfach hinzugefügt
            linien.add(l);
            form.add(l);
            punkte.add(new Punkt(l.start.x, l.start.y));
            punkte.add(new Punkt(l.end.x, l.end.y));
            laengeLinien.add(laenge(l));
            return true;
        } else {
            if (l.equals(linien.get(0)) || l.equals(linien.get(linien.size() - 1))) return false;
            float ll = laenge(l);
            Punkt lp1 = new Punkt(l.start.x, l.start.y);
            Punkt lp2 = new Punkt(l.end.x, l.end.y);

            boolean linieHinzugefuegt = false;
            int a = 0;
            float a0 = laenge(punkte.get(0), lp1) / laengeLinien.get(0);
            float a1 = laenge(punkte.get(0), lp2) / laengeLinien.get(0);
            float a2 = laenge(punkte.get(punkte.size() - 1), lp1) / laengeLinien.get(laengeLinien.size() - 1);
            float a3 = laenge(punkte.get(punkte.size() - 1), lp2) / laengeLinien.get(laengeLinien.size() - 1);
            if (winkel(l ,linien.get(0)) < minWinkelUnterschied) {
                a0 = Float.MAX_VALUE;
                a1 = Float.MAX_VALUE;
            }
            if (winkel(l, linien.get(linien.size() - 1)) < minWinkelUnterschied) {
                a2 = Float.MAX_VALUE;
                a3 = Float.MAX_VALUE;
            }
            float[] abstaende = {a0, a1, a2, a3};
            a = kleinsterWert(abstaende);
            if (abstaende[a] < abweichung) {
                Line nl = new Line(0, 0, 100, 100);//Die eingetragenen Werte werden nie benutzt sondern überschrieben
                linieHinzugefuegt = true;
                switch (a) {
                    case 0:
                        if (ll > laengeLinien.get(0)) {
                            nl = new Line(punkte.get(1).x, punkte.get(1).y, lp1.x, lp1.y);
                            linien.addFirst(l);
                            form.set(0, nl);//Die alte Linie wird verändert
                            form.addFirst(l);//Die neue Linie wird unverändert hinzugefügt
                            laengeLinien.set(0, laenge(nl));
                            laengeLinien.addFirst(ll);
                            punkte.set(0, lp1);
                            punkte.addFirst(lp2);
                        } else {
                            nl = new Line(punkte.get(0).x, punkte.get(0).y, lp2.x, lp2.y);
                            linien.addFirst(l);
                            form.addFirst(nl);//Die neue Linie wird verändert hinzugefügt
                            laengeLinien.addFirst(laenge(nl));
                            punkte.addFirst(lp2);
                        }
                        break;
                    case 1:
                        if (ll > laengeLinien.get(0)) {
                            nl = new Line(punkte.get(1).x, punkte.get(1).y, lp2.x, lp2.y);
                            linien.addFirst(l);
                            form.set(0, nl);
                            form.addFirst(l);
                            laengeLinien.set(0, laenge(nl));
                            laengeLinien.addFirst(ll);
                            punkte.set(0, lp2);
                            punkte.addFirst(lp1);
                        } else {
                            nl = new Line(punkte.get(0).x, punkte.get(0).y, lp1.x, lp1.y);
                            linien.addFirst(l);
                            form.addFirst(nl);
                            laengeLinien.addFirst(laenge(nl));
                            punkte.addFirst(lp1);
                        }
                        break;
                    case 2:
                        if (ll > laengeLinien.get(laengeLinien.size() - 1)) {
                            nl = new Line(punkte.get(punkte.size() - 2).x, punkte.get(punkte.size() - 2).y, lp1.x, lp1.y);
                            linien.addLast(l);
                            form.set(form.size() - 1, nl);
                            form.addLast(l);
                            laengeLinien.set(laengeLinien.size() - 1, laenge(nl));
                            laengeLinien.addLast(ll);
                            punkte.set(punkte.size() - 1, lp1);
                            punkte.addLast(lp2);
                        } else {
                            nl = new Line(punkte.get(punkte.size() - 1).x, punkte.get(punkte.size() - 1).y, lp2.x, lp2.y);
                            linien.addLast(l);
                            form.addLast(nl);
                            laengeLinien.addLast(laenge(nl));
                            punkte.addLast(lp2);
                        }
                        break;
                    case 3:
                        if (ll > laengeLinien.get(laengeLinien.size() - 1)) {
                            nl = new Line(punkte.get(punkte.size() - 2).x, punkte.get(punkte.size() - 2).y, lp2.x, lp2.y);
                            linien.addLast(l);
                            form.set(form.size() - 1, nl);
                            form.addLast(l);
                            laengeLinien.set(laengeLinien.size() - 1, laenge(nl));
                            laengeLinien.addLast(ll);
                            punkte.set(punkte.size() - 1, lp2);
                            punkte.addLast(lp1);
                        } else {
                            nl = new Line(punkte.get(punkte.size() - 1).x, punkte.get(punkte.size() - 1).y, lp1.x, lp1.y);
                            linien.addLast(l);
                            form.addLast(nl);
                            laengeLinien.addLast(laenge(nl));
                            punkte.addLast(lp1);
                        }
                        break;

                }
            }


            if (linieHinzugefuegt) {//Überprüfung ob die Form vollständig ist
                if (linien.size() > 2) {
                    if (laengeLinien.get(laengeLinien.size() - 1) > laengeLinien.get(0)) {
                        if (laenge(punkte.get(0), punkte.get(punkte.size() - 1)) / laengeLinien.get(0) < abweichung) {
                            Line nl = new Line(punkte.get(1).x, punkte.get(1).y, punkte.get(punkte.size() - 1).x, punkte.get(punkte.size() - 1).y);
                            form.set(0, nl);
                            laengeLinien.set(0, laenge(nl));
                            punkte.remove(0);
                            fullyConnected = true;
                        }
                    } else if (laenge(punkte.get(0), punkte.get(punkte.size() - 1)) / laengeLinien.get(laengeLinien.size() - 1) < abweichung) {
                        Line nl = new Line(punkte.get(0).x, punkte.get(0).y, punkte.get(punkte.size() - 2).x, punkte.get(punkte.size() - 2).y);
                        form.set(form.size() - 1, nl);
                        laengeLinien.set(laengeLinien.size() - 1, laenge(nl));
                        punkte.remove(punkte.size() - 1);
                        fullyConnected = true;
                    }
                }
                return true;
            }
        }
        return false;
    }


    public float laenge(Line l) {
        float x1 = l.start.x;
        float y1 = l.start.y;
        float x2 = l.end.x;
        float y2 = l.end.y;
        return (float) Math.sqrt(Math.pow(y2-y1, 2)+Math.pow(x2-x1, 2));
    }

    public float laenge(Punkt p1, Punkt p2) {
        return (float) Math.sqrt(Math.pow(p2.y-p1.y, 2)+Math.pow(p2.x-p1.x, 2));
    }

    public float winkel(Line l) {
        //Wenn ein Punkt der Linie (0/0) ist wird NaN zurückgegebn, da der Winkel zwischen einem Nullvektor und
        //einem anderen Vektor nicht berechnet werden kann
        float x1 = l.start.x;
        float y1 = l.start.y;
        float x2 = l.end.x;
        float y2 = l.end.y;
        return (float)Math.acos(Math.abs(x1*x2+y1*y2)/(Math.sqrt(Math.pow(x1, 2)+Math.pow(y1, 2))*Math.sqrt(Math.pow(x2, 2)+Math.pow(y2, 2))));
    }
    public float winkel(Line l1, Line l2){
        //Gibt den Winkel zwischen zwei Linien zurück (der Winkel ist zwischen 0 und PI/2)
        float v1x = l1.end.x - l1.start.x;
        float v1y = l1.end.y - l1.start.y;
        float v2x = l2.end.x - l2.start.x;
        float v2y = l2.end.y - l2.start.y;
        float sp = Math.abs(v1x*v2x+v1y*v2y);
        float n1 = (float) Math.sqrt(Math.pow(v1x, 2)+Math.pow(v1y, 2));
        float n2 = (float) Math.sqrt(Math.pow(v2x, 2)+Math.pow(v2y, 2));
        return (float)Math.acos(sp/(n1*n2));
    }

    public int kleinsterWert(float[] array) {
        if (array.length<=1)return 0;
        float minWert = array[0];
        int pos = 0;
        for (int i = 0; i<array.length; i++) {
            if (array[i]<minWert) {
                pos = i;
                minWert = array[i];
            }
        }
        return pos;
    }
}
